VERSION 5.00
Begin VB.Form frmBitmaps 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Bitmap API's [Drawing]"
   ClientHeight    =   4830
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5940
   Icon            =   "GDI Drawing.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   322
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   396
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrRotate 
      Enabled         =   0   'False
      Interval        =   20
      Left            =   0
      Top             =   0
   End
   Begin VB.PictureBox picRotate 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1695
      Left            =   3480
      ScaleHeight     =   1635
      ScaleWidth      =   2355
      TabIndex        =   0
      Top             =   3000
      Width           =   2415
   End
End
Attribute VB_Name = "frmBitmaps"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'==================================================================
'
' GDI Painting DLL Sample
'
' 6 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================



#Const CREATE_NEW_DC = False
#Const USE_GDI_BATCH = True


'------------------------------------------------------------------
' Extra API's

' "Timeout" api (just sleep for (q)basic programmers)
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

' Get Desktop DC
Private Declare Function GetDesktopWindow Lib "user32" () As Long


'------------------------------------------------------------------
' Public bitmaps for rotation sequense. These bitmaps won't
' be destroyed, so we don't have to rebuild them every time

Private dcRotated As GDIDC
Private dcRotateEx As GDIDCEx


'------------------------------------------------------------------
' Start randomize

Private Sub Form_Initialize()
  Call VBA.Randomize
End Sub



'------------------------------------------------------------------
' Demonstration of the DC, Bitmap, Brush and Pen classes

Private Sub Form_Load()
  
  ' 1) Create the painting area and
  '    the required pencils and brushes.
  
  ' Device Context, the drawing workspace
  Dim dcWnd As DCWindows
  Dim dcPaint As GDIDC
  Dim dcPaintEx As GDIDCEx
  
  ' Pencils for drawing lines.
  Dim penSmall As GDIPen
  Dim penLarge As GDIPen
  Dim penDash As GDIPen
  
  ' Brushed for filling shapes
  Dim bshColor As GDIBrush
  Dim bshHatch As GDIBrush
  
  ' Other drawing objects
  Dim fntNew As GDIFont
  
  ' Desktop handles
  Dim hWndScreen As OLE_HANDLE
  Dim hDCScreen As OLE_HANDLE
  
  ' Misc
  Dim PicWidth As Long
  Dim picHeight As Long
  Dim ApplyWave As Boolean
  
  
  ' Get Input
  ApplyWave = MsgBox("Appy a wave effect to the images drawn? (takes some time)", vbQuestion Or vbYesNo) = vbYes
  
  
  ' Create paiting workspace
  #If CREATE_NEW_DC Then
    Set dcPaint = GDIAttachDC(Me.hDC, False) ' Read the width/height/colordepth properties
    Set dcPaint = gdicreatedcc(dcPaint.SelBitmap.Width, dcPaint.SelBitmap.Height, (dcPaint.SelBitmap.ColorDepth = 1), dcPaint.hDC)
  #Else
    ' Edit current dc
    Set dcPaint = GDIAttachDC(Me.hDC, False) ' Never destroy a window dc!!
  #End If
  
  ' Load painting tools using workspace base
  ' The original dcPaint object can also be
  ' accessed like this: dcPaintEx.DC,
  ' but you can always refer to the original
  ' GDIDC object, if you prefere so.
  Set dcPaintEx = GDIAttachDCEx(dcPaint)
  
  ' Create painting tools.
  Set penSmall = gdicreatepen()                     ' Create small pen with default properties
  Set penLarge = gdicreatepen(vbBlack, , 2)         ' Create large pen.
  Set penDash = gdicreatepen(vbGreen, penStyleDash) ' Create green dashed pen.
  Set bshColor = GDICreateBrush(vbRed)              ' Create solid brush for coloring.
  Set bshHatch = GDICreateBrush(vbBlue, bshStyleHatched, bshHatchDiagNESW) ' Hatched brush
  Set fntNew = GDICreateFont("Arial", , , , fntWeightNormal, , True)    ' Create font
  
  #If USE_GDI_BATCH Then
    ' Define how many boolean-return-value-GDI-functions
    ' should be called from this thread before they are
    ' executed all at once from the batch.
    ' Special values: 1 = disable, 0 = use default. (See GDIBatchLimitSpecials Enum)
    GDIBatchLimit = 20
  #End If
  
  
  ' 2) Now, lets do some drawing stuff!
  '    Fun starts here...
  
  ' Draw gradient
  ' Note: calling something from a subobject in the dc class will
  ' initialize the subobject automatically at that moment.
  ' That means that half of the dc functions have not been loaded yet,
  ' and that saves some memory!
  Call dcPaintEx.Effects.GradientFill(0, 0, dcPaintEx.dc.SelBitmap.Width, dcPaintEx.dc.SelBitmap.Height / 2, vbWhite, RGB(0, 0, 128))
  Call dcPaintEx.Effects.GradientFill(0, dcPaintEx.dc.SelBitmap.Height / 2, dcPaintEx.dc.SelBitmap.Width, dcPaintEx.dc.SelBitmap.Height, vbButtonFace, vbWhite)
  
  ' Cool pit
  Call dcPaintEx.Effects.GravitationPit(120, 60, 80)
  
  ' Capture desktop window
'  hWndScreen = GetDesktopWindow()
'  Set dcWnd = GDIAttachDCWnd(hWndScreen, dcWndRetreiveDC)
'  Call dcPaintEx.CaptureFrom(dcWnd.DCEx.dc.hDC, 7, 1, 88, 55, 70, 220)
'  Set dcWnd = Nothing
'  Call dcPaintEx.UIDrawing.DrawBorder(70, 220, 151, 274, dcBorderSunken)
  
  ' Fill style is transparent; empty parts as result of painting won't be filled.
  dcPaintEx.Drawing.FillStyle = dcBgModeTransparent
  
  ' Select the green dashed pen, draw a line.
  Set dcPaintEx.dc.SelPen = penDash
  Call dcPaintEx.Drawing.DrawLine(80, 20, 250, 20)
  
  ' Select new drawing objects (pen/brush)
  ' The dashed pen can be destroyed when
  ' it is no longer selected in the dc.
  Set dcPaintEx.dc.SelPen = penLarge
  Set dcPaintEx.dc.SelBrush = bshColor
  Set penDash = Nothing ' Destroy pen when all object references are gone and OwnsHandle = True
  
  ' Draw a winding polygon (with 6 xy-coords).
  dcPaintEx.Drawing.PolyFillMode = dcFillModeWinding
  Call dcPaintEx.Drawing.DrawPolygon(True, GDIMakeCoords(100, 100, 10, 100, 200, 200, 100, 100, 10, 10, 100, 200))
  
  ' Deselect (and auto-destroy) the brush so we can change the color.
  Call dcPaintEx.dc.RestoreBrush
  Set bshColor = GDICreateBrush(vbBlue)
  
  ' Select the modified brush and the small pen.
  Set dcPaintEx.dc.SelPen = penSmall
  Set dcPaintEx.dc.SelBrush = bshColor
  
  ' Now we're going to draw a Chord, Pie and
  ' Arc with different brushes and pencils
  Call dcPaintEx.Drawing.DrawChord(160, 10, 360, 110, 10, 50, 200, 200)
  Set dcPaintEx.dc.SelBrush = bshHatch
  Call dcPaintEx.Drawing.DrawPie(160, 10, 360, 110, 10, 50, 200, 200)
  Set dcPaintEx.dc.SelPen = penSmall
  Set dcPaintEx.dc.SelBrush = bshColor
  Call dcPaintEx.Drawing.DrawEllipse(156, 6, 364, 114, 10, 50, 200, 200)
  
  ' Draw round rect
  Call dcPaintEx.Drawing.DrawRect(270, 20, 370, 120, 64, 128)
  
  ' Change the hatch brush the the new style
  ' The background color defines the color of the
  ' transparent parts of the hatched brush
  dcPaintEx.Drawing.BackColor = RGB(150, 150, 150)
  Set bshHatch = GDICreateBrush(vbYellow, bshStyleHatched, bshHatchDiagCross)
  
  ' Draw a hatched rectangle and draw some text in it.
  Set dcPaintEx.dc.SelBrush = bshHatch
  Set dcPaintEx.dc.SelFont = fntNew
  Call dcPaintEx.Drawing.DrawRectEx(180, 150, 400, 170, True)
  Call dcPaintEx.TextDrawing.DrawTextEx("Enjoy the power of GDI API!", 180, 150, 400, 170, dcDrawWordBreak Or dcDrawAlignCenter Or dcDrawAlignMiddle, 10, 10)
  Call dcPaintEx.dc.RestoreFont
  
  ' Replace Color!!
  Set dcPaintEx.dc.SelBrush = bshColor
  Call dcPaintEx.Effects.ReplaceColor(vbBlue, vbYellow, 200, 70, 350, 100)
  
  
  If ApplyWave Then
    ' Wave!!
    Call dcPaintEx.Effects.Wave
  End If
  
  ' Draw sortof banner
  Set fntNew = GDICreateFont("Verdana", , 15)
  Set dcPaintEx.dc.SelFont = fntNew
  Call dcPaintEx.TextDrawing.DrawTextEx("Find out more about programming!", 10, 280, , , dcDrawAlignLeft)
  dcPaintEx.TextDrawing.TextColor = vbBlue
  Call dcPaintEx.TextDrawing.DrawTextEx("http://www.codingdomain.com", 10, 290, , , dcDrawAlignLeft)
  
  
  ' Destroy painting objects but:
  ' restore original objects first, that
  ' deselects the custom pen/brush/font used.
  Call dcPaintEx.dc.RestorePen
  Call dcPaintEx.dc.RestoreBrush
  Call dcPaintEx.dc.RestoreFont
  Set penSmall = Nothing
  Set penLarge = Nothing
  Set bshColor = Nothing
  Set bshHatch = Nothing
  Set fntNew = Nothing
  
  #If USE_GDI_BATCH Then
    Call GDIBatchFlush ' Execute all other functions from the batch.
    GDIBatchLimit = GDIBatchLimitSpecials.dcBatchRestoreDefault
  #End If
  
  #If CREATE_NEW_DC Then
    ' Draw transparent bitmap from dc to this window dc.
    Call dcPaintEx.DrawTo(Me.hDC, 0, 0, 400, 300, , , , vbWhite)
  #End If
  If Me.AutoRedraw And Not Me.Visible Then Call Me.Refresh
  Set dcPaint = Nothing
  
  ' Prepare rotation bitmap
  PicWidth = picRotate.Width / 2
  picHeight = picRotate.Height / 2
  Set penLarge = gdicreatepen(vbBlack, , 4)
  Set dcRotateEx = GDIAttachDCEx(gdicreatedcc(PicWidth, picHeight, True))
  Set dcRotateEx.dc.SelPen = penLarge
  Call dcRotateEx.Drawing.DrawRect(10, 10, PicWidth - 10, picHeight - 10, 1, 1)
  Call dcRotateEx.Drawing.DrawLine(10, 10, PicWidth / 2, picHeight / 2)
  Call dcRotateEx.Drawing.DrawLine(PicWidth - 10, 10, PicWidth / 2, picHeight / 2)
  Call dcRotateEx.dc.RestorePen
  Set penLarge = Nothing
  tmrRotate.Enabled = True
End Sub

'------------------------------------------------------------------
' Rotate Animation

Private Sub tmrRotate_Timer()
  Static Degrees As Double
  Dim dcRotatedEx As GDIDCEx
  Degrees = Degrees + 1 ' (Degrees + IIf(Rnd() > 0.5, 10, -10))
  Call dcRotateEx.Effects.Rotate(dcRotated, CRadials(Degrees))
  Set dcRotatedEx = GDIAttachDCEx(dcRotated)
  Call dcRotatedEx.Effects.StretchTo(picRotate.hDC, 0, 0, picRotate.Width, picRotate.Height, 0, 0, dcRotated.SelBitmap.Width, dcRotated.SelBitmap.Height)
  If picRotate.AutoRedraw Then picRotate.Refresh
End Sub


'------------------------------------------------------------------
' Convert Radials to Degrees

Private Function CRadials(Degrees As Double) As Double
  CRadials = (Degrees / 180 * 3.14159265358979)
End Function



'------------------------------------------------------------------
' Kill bitmaps

Private Sub Form_Unload(Cancel As Integer)
  Set dcRotateEx = Nothing
  Set dcRotated = Nothing
End Sub



'------------------------------------------------------------------
' Banner

Private Sub Form_Click()
  MsgBox "Copyright  2001 - Diederik van der Boor" & vbCrLf _
       & vbCrLf _
       & "Anyone is allowed to use this software freely, as long as" & vbCrLf _
       & "the the copright information in the source code remains intact." & vbCrLf _
       & vbCrLf _
       & "http://www.codingdomain.com"
End Sub


